package com.mvc.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

public class TSetupExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public TSetupExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<java.sql.Date>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andIdIsNull() {
            addCriterion("ID is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("ID is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("ID =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("ID <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("ID >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("ID >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("ID <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("ID <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("ID in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("ID not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("ID between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("ID not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andSetupIdIsNull() {
            addCriterion("SETUP_ID is null");
            return (Criteria) this;
        }

        public Criteria andSetupIdIsNotNull() {
            addCriterion("SETUP_ID is not null");
            return (Criteria) this;
        }

        public Criteria andSetupIdEqualTo(String value) {
            addCriterion("SETUP_ID =", value, "setupId");
            return (Criteria) this;
        }

        public Criteria andSetupIdNotEqualTo(String value) {
            addCriterion("SETUP_ID <>", value, "setupId");
            return (Criteria) this;
        }

        public Criteria andSetupIdGreaterThan(String value) {
            addCriterion("SETUP_ID >", value, "setupId");
            return (Criteria) this;
        }

        public Criteria andSetupIdGreaterThanOrEqualTo(String value) {
            addCriterion("SETUP_ID >=", value, "setupId");
            return (Criteria) this;
        }

        public Criteria andSetupIdLessThan(String value) {
            addCriterion("SETUP_ID <", value, "setupId");
            return (Criteria) this;
        }

        public Criteria andSetupIdLessThanOrEqualTo(String value) {
            addCriterion("SETUP_ID <=", value, "setupId");
            return (Criteria) this;
        }

        public Criteria andSetupIdLike(String value) {
            addCriterion("SETUP_ID like", value, "setupId");
            return (Criteria) this;
        }

        public Criteria andSetupIdNotLike(String value) {
            addCriterion("SETUP_ID not like", value, "setupId");
            return (Criteria) this;
        }

        public Criteria andSetupIdIn(List<String> values) {
            addCriterion("SETUP_ID in", values, "setupId");
            return (Criteria) this;
        }

        public Criteria andSetupIdNotIn(List<String> values) {
            addCriterion("SETUP_ID not in", values, "setupId");
            return (Criteria) this;
        }

        public Criteria andSetupIdBetween(String value1, String value2) {
            addCriterion("SETUP_ID between", value1, value2, "setupId");
            return (Criteria) this;
        }

        public Criteria andSetupIdNotBetween(String value1, String value2) {
            addCriterion("SETUP_ID not between", value1, value2, "setupId");
            return (Criteria) this;
        }

        public Criteria andStationCodeIsNull() {
            addCriterion("STATION_CODE is null");
            return (Criteria) this;
        }

        public Criteria andStationCodeIsNotNull() {
            addCriterion("STATION_CODE is not null");
            return (Criteria) this;
        }

        public Criteria andStationCodeEqualTo(String value) {
            addCriterion("STATION_CODE =", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeNotEqualTo(String value) {
            addCriterion("STATION_CODE <>", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeGreaterThan(String value) {
            addCriterion("STATION_CODE >", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeGreaterThanOrEqualTo(String value) {
            addCriterion("STATION_CODE >=", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeLessThan(String value) {
            addCriterion("STATION_CODE <", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeLessThanOrEqualTo(String value) {
            addCriterion("STATION_CODE <=", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeLike(String value) {
            addCriterion("STATION_CODE like", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeNotLike(String value) {
            addCriterion("STATION_CODE not like", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeIn(List<String> values) {
            addCriterion("STATION_CODE in", values, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeNotIn(List<String> values) {
            addCriterion("STATION_CODE not in", values, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeBetween(String value1, String value2) {
            addCriterion("STATION_CODE between", value1, value2, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeNotBetween(String value1, String value2) {
            addCriterion("STATION_CODE not between", value1, value2, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationNameIsNull() {
            addCriterion("STATION_NAME is null");
            return (Criteria) this;
        }

        public Criteria andStationNameIsNotNull() {
            addCriterion("STATION_NAME is not null");
            return (Criteria) this;
        }

        public Criteria andStationNameEqualTo(String value) {
            addCriterion("STATION_NAME =", value, "stationName");
            return (Criteria) this;
        }

        public Criteria andStationNameNotEqualTo(String value) {
            addCriterion("STATION_NAME <>", value, "stationName");
            return (Criteria) this;
        }

        public Criteria andStationNameGreaterThan(String value) {
            addCriterion("STATION_NAME >", value, "stationName");
            return (Criteria) this;
        }

        public Criteria andStationNameGreaterThanOrEqualTo(String value) {
            addCriterion("STATION_NAME >=", value, "stationName");
            return (Criteria) this;
        }

        public Criteria andStationNameLessThan(String value) {
            addCriterion("STATION_NAME <", value, "stationName");
            return (Criteria) this;
        }

        public Criteria andStationNameLessThanOrEqualTo(String value) {
            addCriterion("STATION_NAME <=", value, "stationName");
            return (Criteria) this;
        }

        public Criteria andStationNameLike(String value) {
            addCriterion("STATION_NAME like", value, "stationName");
            return (Criteria) this;
        }

        public Criteria andStationNameNotLike(String value) {
            addCriterion("STATION_NAME not like", value, "stationName");
            return (Criteria) this;
        }

        public Criteria andStationNameIn(List<String> values) {
            addCriterion("STATION_NAME in", values, "stationName");
            return (Criteria) this;
        }

        public Criteria andStationNameNotIn(List<String> values) {
            addCriterion("STATION_NAME not in", values, "stationName");
            return (Criteria) this;
        }

        public Criteria andStationNameBetween(String value1, String value2) {
            addCriterion("STATION_NAME between", value1, value2, "stationName");
            return (Criteria) this;
        }

        public Criteria andStationNameNotBetween(String value1, String value2) {
            addCriterion("STATION_NAME not between", value1, value2, "stationName");
            return (Criteria) this;
        }

        public Criteria andDeviceSnIsNull() {
            addCriterion("DEVICE_SN is null");
            return (Criteria) this;
        }

        public Criteria andDeviceSnIsNotNull() {
            addCriterion("DEVICE_SN is not null");
            return (Criteria) this;
        }

        public Criteria andDeviceSnEqualTo(String value) {
            addCriterion("DEVICE_SN =", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotEqualTo(String value) {
            addCriterion("DEVICE_SN <>", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnGreaterThan(String value) {
            addCriterion("DEVICE_SN >", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnGreaterThanOrEqualTo(String value) {
            addCriterion("DEVICE_SN >=", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnLessThan(String value) {
            addCriterion("DEVICE_SN <", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnLessThanOrEqualTo(String value) {
            addCriterion("DEVICE_SN <=", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnLike(String value) {
            addCriterion("DEVICE_SN like", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotLike(String value) {
            addCriterion("DEVICE_SN not like", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnIn(List<String> values) {
            addCriterion("DEVICE_SN in", values, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotIn(List<String> values) {
            addCriterion("DEVICE_SN not in", values, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnBetween(String value1, String value2) {
            addCriterion("DEVICE_SN between", value1, value2, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotBetween(String value1, String value2) {
            addCriterion("DEVICE_SN not between", value1, value2, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andSetupTimeIsNull() {
            addCriterion("SETUP_TIME is null");
            return (Criteria) this;
        }

        public Criteria andSetupTimeIsNotNull() {
            addCriterion("SETUP_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andSetupTimeEqualTo(Date value) {
            addCriterion("SETUP_TIME =", value, "setupTime");
            return (Criteria) this;
        }

        public Criteria andSetupTimeNotEqualTo(Date value) {
            addCriterion("SETUP_TIME <>", value, "setupTime");
            return (Criteria) this;
        }

        public Criteria andSetupTimeGreaterThan(Date value) {
            addCriterion("SETUP_TIME >", value, "setupTime");
            return (Criteria) this;
        }

        public Criteria andSetupTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("SETUP_TIME >=", value, "setupTime");
            return (Criteria) this;
        }

        public Criteria andSetupTimeLessThan(Date value) {
            addCriterion("SETUP_TIME <", value, "setupTime");
            return (Criteria) this;
        }

        public Criteria andSetupTimeLessThanOrEqualTo(Date value) {
            addCriterion("SETUP_TIME <=", value, "setupTime");
            return (Criteria) this;
        }

        public Criteria andSetupTimeIn(List<Date> values) {
            addCriterion("SETUP_TIME in", values, "setupTime");
            return (Criteria) this;
        }

        public Criteria andSetupTimeNotIn(List<Date> values) {
            addCriterion("SETUP_TIME not in", values, "setupTime");
            return (Criteria) this;
        }

        public Criteria andSetupTimeBetween(Date value1, Date value2) {
            addCriterion("SETUP_TIME between", value1, value2, "setupTime");
            return (Criteria) this;
        }

        public Criteria andSetupTimeNotBetween(Date value1, Date value2) {
            addCriterion("SETUP_TIME not between", value1, value2, "setupTime");
            return (Criteria) this;
        }

        public Criteria andSetupManIsNull() {
            addCriterion("SETUP_MAN is null");
            return (Criteria) this;
        }

        public Criteria andSetupManIsNotNull() {
            addCriterion("SETUP_MAN is not null");
            return (Criteria) this;
        }

        public Criteria andSetupManEqualTo(String value) {
            addCriterion("SETUP_MAN =", value, "setupMan");
            return (Criteria) this;
        }

        public Criteria andSetupManNotEqualTo(String value) {
            addCriterion("SETUP_MAN <>", value, "setupMan");
            return (Criteria) this;
        }

        public Criteria andSetupManGreaterThan(String value) {
            addCriterion("SETUP_MAN >", value, "setupMan");
            return (Criteria) this;
        }

        public Criteria andSetupManGreaterThanOrEqualTo(String value) {
            addCriterion("SETUP_MAN >=", value, "setupMan");
            return (Criteria) this;
        }

        public Criteria andSetupManLessThan(String value) {
            addCriterion("SETUP_MAN <", value, "setupMan");
            return (Criteria) this;
        }

        public Criteria andSetupManLessThanOrEqualTo(String value) {
            addCriterion("SETUP_MAN <=", value, "setupMan");
            return (Criteria) this;
        }

        public Criteria andSetupManLike(String value) {
            addCriterion("SETUP_MAN like", value, "setupMan");
            return (Criteria) this;
        }

        public Criteria andSetupManNotLike(String value) {
            addCriterion("SETUP_MAN not like", value, "setupMan");
            return (Criteria) this;
        }

        public Criteria andSetupManIn(List<String> values) {
            addCriterion("SETUP_MAN in", values, "setupMan");
            return (Criteria) this;
        }

        public Criteria andSetupManNotIn(List<String> values) {
            addCriterion("SETUP_MAN not in", values, "setupMan");
            return (Criteria) this;
        }

        public Criteria andSetupManBetween(String value1, String value2) {
            addCriterion("SETUP_MAN between", value1, value2, "setupMan");
            return (Criteria) this;
        }

        public Criteria andSetupManNotBetween(String value1, String value2) {
            addCriterion("SETUP_MAN not between", value1, value2, "setupMan");
            return (Criteria) this;
        }

        public Criteria andFloorRsrpIsNull() {
            addCriterion("FLOOR_RSRP is null");
            return (Criteria) this;
        }

        public Criteria andFloorRsrpIsNotNull() {
            addCriterion("FLOOR_RSRP is not null");
            return (Criteria) this;
        }

        public Criteria andFloorRsrpEqualTo(Integer value) {
            addCriterion("FLOOR_RSRP =", value, "floorRsrp");
            return (Criteria) this;
        }

        public Criteria andFloorRsrpNotEqualTo(Integer value) {
            addCriterion("FLOOR_RSRP <>", value, "floorRsrp");
            return (Criteria) this;
        }

        public Criteria andFloorRsrpGreaterThan(Integer value) {
            addCriterion("FLOOR_RSRP >", value, "floorRsrp");
            return (Criteria) this;
        }

        public Criteria andFloorRsrpGreaterThanOrEqualTo(Integer value) {
            addCriterion("FLOOR_RSRP >=", value, "floorRsrp");
            return (Criteria) this;
        }

        public Criteria andFloorRsrpLessThan(Integer value) {
            addCriterion("FLOOR_RSRP <", value, "floorRsrp");
            return (Criteria) this;
        }

        public Criteria andFloorRsrpLessThanOrEqualTo(Integer value) {
            addCriterion("FLOOR_RSRP <=", value, "floorRsrp");
            return (Criteria) this;
        }

        public Criteria andFloorRsrpIn(List<Integer> values) {
            addCriterion("FLOOR_RSRP in", values, "floorRsrp");
            return (Criteria) this;
        }

        public Criteria andFloorRsrpNotIn(List<Integer> values) {
            addCriterion("FLOOR_RSRP not in", values, "floorRsrp");
            return (Criteria) this;
        }

        public Criteria andFloorRsrpBetween(Integer value1, Integer value2) {
            addCriterion("FLOOR_RSRP between", value1, value2, "floorRsrp");
            return (Criteria) this;
        }

        public Criteria andFloorRsrpNotBetween(Integer value1, Integer value2) {
            addCriterion("FLOOR_RSRP not between", value1, value2, "floorRsrp");
            return (Criteria) this;
        }

        public Criteria andStationContactIsNull() {
            addCriterion("STATION_CONTACT is null");
            return (Criteria) this;
        }

        public Criteria andStationContactIsNotNull() {
            addCriterion("STATION_CONTACT is not null");
            return (Criteria) this;
        }

        public Criteria andStationContactEqualTo(String value) {
            addCriterion("STATION_CONTACT =", value, "stationContact");
            return (Criteria) this;
        }

        public Criteria andStationContactNotEqualTo(String value) {
            addCriterion("STATION_CONTACT <>", value, "stationContact");
            return (Criteria) this;
        }

        public Criteria andStationContactGreaterThan(String value) {
            addCriterion("STATION_CONTACT >", value, "stationContact");
            return (Criteria) this;
        }

        public Criteria andStationContactGreaterThanOrEqualTo(String value) {
            addCriterion("STATION_CONTACT >=", value, "stationContact");
            return (Criteria) this;
        }

        public Criteria andStationContactLessThan(String value) {
            addCriterion("STATION_CONTACT <", value, "stationContact");
            return (Criteria) this;
        }

        public Criteria andStationContactLessThanOrEqualTo(String value) {
            addCriterion("STATION_CONTACT <=", value, "stationContact");
            return (Criteria) this;
        }

        public Criteria andStationContactLike(String value) {
            addCriterion("STATION_CONTACT like", value, "stationContact");
            return (Criteria) this;
        }

        public Criteria andStationContactNotLike(String value) {
            addCriterion("STATION_CONTACT not like", value, "stationContact");
            return (Criteria) this;
        }

        public Criteria andStationContactIn(List<String> values) {
            addCriterion("STATION_CONTACT in", values, "stationContact");
            return (Criteria) this;
        }

        public Criteria andStationContactNotIn(List<String> values) {
            addCriterion("STATION_CONTACT not in", values, "stationContact");
            return (Criteria) this;
        }

        public Criteria andStationContactBetween(String value1, String value2) {
            addCriterion("STATION_CONTACT between", value1, value2, "stationContact");
            return (Criteria) this;
        }

        public Criteria andStationContactNotBetween(String value1, String value2) {
            addCriterion("STATION_CONTACT not between", value1, value2, "stationContact");
            return (Criteria) this;
        }

        public Criteria andStationAddressIsNull() {
            addCriterion("STATION_ADDRESS is null");
            return (Criteria) this;
        }

        public Criteria andStationAddressIsNotNull() {
            addCriterion("STATION_ADDRESS is not null");
            return (Criteria) this;
        }

        public Criteria andStationAddressEqualTo(String value) {
            addCriterion("STATION_ADDRESS =", value, "stationAddress");
            return (Criteria) this;
        }

        public Criteria andStationAddressNotEqualTo(String value) {
            addCriterion("STATION_ADDRESS <>", value, "stationAddress");
            return (Criteria) this;
        }

        public Criteria andStationAddressGreaterThan(String value) {
            addCriterion("STATION_ADDRESS >", value, "stationAddress");
            return (Criteria) this;
        }

        public Criteria andStationAddressGreaterThanOrEqualTo(String value) {
            addCriterion("STATION_ADDRESS >=", value, "stationAddress");
            return (Criteria) this;
        }

        public Criteria andStationAddressLessThan(String value) {
            addCriterion("STATION_ADDRESS <", value, "stationAddress");
            return (Criteria) this;
        }

        public Criteria andStationAddressLessThanOrEqualTo(String value) {
            addCriterion("STATION_ADDRESS <=", value, "stationAddress");
            return (Criteria) this;
        }

        public Criteria andStationAddressLike(String value) {
            addCriterion("STATION_ADDRESS like", value, "stationAddress");
            return (Criteria) this;
        }

        public Criteria andStationAddressNotLike(String value) {
            addCriterion("STATION_ADDRESS not like", value, "stationAddress");
            return (Criteria) this;
        }

        public Criteria andStationAddressIn(List<String> values) {
            addCriterion("STATION_ADDRESS in", values, "stationAddress");
            return (Criteria) this;
        }

        public Criteria andStationAddressNotIn(List<String> values) {
            addCriterion("STATION_ADDRESS not in", values, "stationAddress");
            return (Criteria) this;
        }

        public Criteria andStationAddressBetween(String value1, String value2) {
            addCriterion("STATION_ADDRESS between", value1, value2, "stationAddress");
            return (Criteria) this;
        }

        public Criteria andStationAddressNotBetween(String value1, String value2) {
            addCriterion("STATION_ADDRESS not between", value1, value2, "stationAddress");
            return (Criteria) this;
        }

        public Criteria andStationLonIsNull() {
            addCriterion("STATION_LON is null");
            return (Criteria) this;
        }

        public Criteria andStationLonIsNotNull() {
            addCriterion("STATION_LON is not null");
            return (Criteria) this;
        }

        public Criteria andStationLonEqualTo(BigDecimal value) {
            addCriterion("STATION_LON =", value, "stationLon");
            return (Criteria) this;
        }

        public Criteria andStationLonNotEqualTo(BigDecimal value) {
            addCriterion("STATION_LON <>", value, "stationLon");
            return (Criteria) this;
        }

        public Criteria andStationLonGreaterThan(BigDecimal value) {
            addCriterion("STATION_LON >", value, "stationLon");
            return (Criteria) this;
        }

        public Criteria andStationLonGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("STATION_LON >=", value, "stationLon");
            return (Criteria) this;
        }

        public Criteria andStationLonLessThan(BigDecimal value) {
            addCriterion("STATION_LON <", value, "stationLon");
            return (Criteria) this;
        }

        public Criteria andStationLonLessThanOrEqualTo(BigDecimal value) {
            addCriterion("STATION_LON <=", value, "stationLon");
            return (Criteria) this;
        }

        public Criteria andStationLonIn(List<BigDecimal> values) {
            addCriterion("STATION_LON in", values, "stationLon");
            return (Criteria) this;
        }

        public Criteria andStationLonNotIn(List<BigDecimal> values) {
            addCriterion("STATION_LON not in", values, "stationLon");
            return (Criteria) this;
        }

        public Criteria andStationLonBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("STATION_LON between", value1, value2, "stationLon");
            return (Criteria) this;
        }

        public Criteria andStationLonNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("STATION_LON not between", value1, value2, "stationLon");
            return (Criteria) this;
        }

        public Criteria andStationLatIsNull() {
            addCriterion("STATION_LAT is null");
            return (Criteria) this;
        }

        public Criteria andStationLatIsNotNull() {
            addCriterion("STATION_LAT is not null");
            return (Criteria) this;
        }

        public Criteria andStationLatEqualTo(BigDecimal value) {
            addCriterion("STATION_LAT =", value, "stationLat");
            return (Criteria) this;
        }

        public Criteria andStationLatNotEqualTo(BigDecimal value) {
            addCriterion("STATION_LAT <>", value, "stationLat");
            return (Criteria) this;
        }

        public Criteria andStationLatGreaterThan(BigDecimal value) {
            addCriterion("STATION_LAT >", value, "stationLat");
            return (Criteria) this;
        }

        public Criteria andStationLatGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("STATION_LAT >=", value, "stationLat");
            return (Criteria) this;
        }

        public Criteria andStationLatLessThan(BigDecimal value) {
            addCriterion("STATION_LAT <", value, "stationLat");
            return (Criteria) this;
        }

        public Criteria andStationLatLessThanOrEqualTo(BigDecimal value) {
            addCriterion("STATION_LAT <=", value, "stationLat");
            return (Criteria) this;
        }

        public Criteria andStationLatIn(List<BigDecimal> values) {
            addCriterion("STATION_LAT in", values, "stationLat");
            return (Criteria) this;
        }

        public Criteria andStationLatNotIn(List<BigDecimal> values) {
            addCriterion("STATION_LAT not in", values, "stationLat");
            return (Criteria) this;
        }

        public Criteria andStationLatBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("STATION_LAT between", value1, value2, "stationLat");
            return (Criteria) this;
        }

        public Criteria andStationLatNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("STATION_LAT not between", value1, value2, "stationLat");
            return (Criteria) this;
        }

        public Criteria andFinishedFlagIsNull() {
            addCriterion("FINISHED_FLAG is null");
            return (Criteria) this;
        }

        public Criteria andFinishedFlagIsNotNull() {
            addCriterion("FINISHED_FLAG is not null");
            return (Criteria) this;
        }

        public Criteria andFinishedFlagEqualTo(String value) {
            addCriterion("FINISHED_FLAG =", value, "finishedFlag");
            return (Criteria) this;
        }

        public Criteria andFinishedFlagNotEqualTo(String value) {
            addCriterion("FINISHED_FLAG <>", value, "finishedFlag");
            return (Criteria) this;
        }

        public Criteria andFinishedFlagGreaterThan(String value) {
            addCriterion("FINISHED_FLAG >", value, "finishedFlag");
            return (Criteria) this;
        }

        public Criteria andFinishedFlagGreaterThanOrEqualTo(String value) {
            addCriterion("FINISHED_FLAG >=", value, "finishedFlag");
            return (Criteria) this;
        }

        public Criteria andFinishedFlagLessThan(String value) {
            addCriterion("FINISHED_FLAG <", value, "finishedFlag");
            return (Criteria) this;
        }

        public Criteria andFinishedFlagLessThanOrEqualTo(String value) {
            addCriterion("FINISHED_FLAG <=", value, "finishedFlag");
            return (Criteria) this;
        }

        public Criteria andFinishedFlagLike(String value) {
            addCriterion("FINISHED_FLAG like", value, "finishedFlag");
            return (Criteria) this;
        }

        public Criteria andFinishedFlagNotLike(String value) {
            addCriterion("FINISHED_FLAG not like", value, "finishedFlag");
            return (Criteria) this;
        }

        public Criteria andFinishedFlagIn(List<String> values) {
            addCriterion("FINISHED_FLAG in", values, "finishedFlag");
            return (Criteria) this;
        }

        public Criteria andFinishedFlagNotIn(List<String> values) {
            addCriterion("FINISHED_FLAG not in", values, "finishedFlag");
            return (Criteria) this;
        }

        public Criteria andFinishedFlagBetween(String value1, String value2) {
            addCriterion("FINISHED_FLAG between", value1, value2, "finishedFlag");
            return (Criteria) this;
        }

        public Criteria andFinishedFlagNotBetween(String value1, String value2) {
            addCriterion("FINISHED_FLAG not between", value1, value2, "finishedFlag");
            return (Criteria) this;
        }

        public Criteria andFinishedTimeIsNull() {
            addCriterion("FINISHED_TIME is null");
            return (Criteria) this;
        }

        public Criteria andFinishedTimeIsNotNull() {
            addCriterion("FINISHED_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andFinishedTimeEqualTo(Date value) {
            addCriterionForJDBCDate("FINISHED_TIME =", value, "finishedTime");
            return (Criteria) this;
        }

        public Criteria andFinishedTimeNotEqualTo(Date value) {
            addCriterionForJDBCDate("FINISHED_TIME <>", value, "finishedTime");
            return (Criteria) this;
        }

        public Criteria andFinishedTimeGreaterThan(Date value) {
            addCriterionForJDBCDate("FINISHED_TIME >", value, "finishedTime");
            return (Criteria) this;
        }

        public Criteria andFinishedTimeGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("FINISHED_TIME >=", value, "finishedTime");
            return (Criteria) this;
        }

        public Criteria andFinishedTimeLessThan(Date value) {
            addCriterionForJDBCDate("FINISHED_TIME <", value, "finishedTime");
            return (Criteria) this;
        }

        public Criteria andFinishedTimeLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("FINISHED_TIME <=", value, "finishedTime");
            return (Criteria) this;
        }

        public Criteria andFinishedTimeIn(List<Date> values) {
            addCriterionForJDBCDate("FINISHED_TIME in", values, "finishedTime");
            return (Criteria) this;
        }

        public Criteria andFinishedTimeNotIn(List<Date> values) {
            addCriterionForJDBCDate("FINISHED_TIME not in", values, "finishedTime");
            return (Criteria) this;
        }

        public Criteria andFinishedTimeBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("FINISHED_TIME between", value1, value2, "finishedTime");
            return (Criteria) this;
        }

        public Criteria andFinishedTimeNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("FINISHED_TIME not between", value1, value2, "finishedTime");
            return (Criteria) this;
        }

        public Criteria andFinishedManIsNull() {
            addCriterion("FINISHED_MAN is null");
            return (Criteria) this;
        }

        public Criteria andFinishedManIsNotNull() {
            addCriterion("FINISHED_MAN is not null");
            return (Criteria) this;
        }

        public Criteria andFinishedManEqualTo(String value) {
            addCriterion("FINISHED_MAN =", value, "finishedMan");
            return (Criteria) this;
        }

        public Criteria andFinishedManNotEqualTo(String value) {
            addCriterion("FINISHED_MAN <>", value, "finishedMan");
            return (Criteria) this;
        }

        public Criteria andFinishedManGreaterThan(String value) {
            addCriterion("FINISHED_MAN >", value, "finishedMan");
            return (Criteria) this;
        }

        public Criteria andFinishedManGreaterThanOrEqualTo(String value) {
            addCriterion("FINISHED_MAN >=", value, "finishedMan");
            return (Criteria) this;
        }

        public Criteria andFinishedManLessThan(String value) {
            addCriterion("FINISHED_MAN <", value, "finishedMan");
            return (Criteria) this;
        }

        public Criteria andFinishedManLessThanOrEqualTo(String value) {
            addCriterion("FINISHED_MAN <=", value, "finishedMan");
            return (Criteria) this;
        }

        public Criteria andFinishedManLike(String value) {
            addCriterion("FINISHED_MAN like", value, "finishedMan");
            return (Criteria) this;
        }

        public Criteria andFinishedManNotLike(String value) {
            addCriterion("FINISHED_MAN not like", value, "finishedMan");
            return (Criteria) this;
        }

        public Criteria andFinishedManIn(List<String> values) {
            addCriterion("FINISHED_MAN in", values, "finishedMan");
            return (Criteria) this;
        }

        public Criteria andFinishedManNotIn(List<String> values) {
            addCriterion("FINISHED_MAN not in", values, "finishedMan");
            return (Criteria) this;
        }

        public Criteria andFinishedManBetween(String value1, String value2) {
            addCriterion("FINISHED_MAN between", value1, value2, "finishedMan");
            return (Criteria) this;
        }

        public Criteria andFinishedManNotBetween(String value1, String value2) {
            addCriterion("FINISHED_MAN not between", value1, value2, "finishedMan");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}